var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx, css } from '@emotion/core';
import { mouseFocusBehavior } from '@workday/canvas-kit-react-common';
import React from 'react';
import { useTab } from './Tabs';
var styles = css(mouseFocusBehavior({
    '&:focus': {
        outline: 'none',
    },
}));
var TabPanel = function (_a) {
    var children = _a.children, _b = _a.name, name = _b === void 0 ? '' : _b, elemProps = __rest(_a, ["children", "name"]);
    var _c = useTab(), id = _c.id, activeTab = _c.activeTab, registerPanel = _c.registerPanel, unregisterPanel = _c.unregisterPanel;
    var _d = React.useState(name), tabName = _d[0], setTabName = _d[1];
    React.useLayoutEffect(function () {
        var tabName = registerPanel(name);
        setTabName(tabName);
        return function () {
            unregisterPanel(tabName);
        };
    }, [name, registerPanel, unregisterPanel]);
    return (jsx("div", __assign({ role: "tabpanel", css: styles, "aria-labelledby": "tab-" + id + "-" + tabName, hidden: !!tabName && tabName !== activeTab, id: "tabpanel-" + id + "-" + tabName, tabIndex: 0 }, elemProps), children));
};
export default TabPanel;
